package bloat_test

import (
	"fmt"
	"testing"

	"git.bivouac.wiki/go/bloat"
)

func TestItem(t *testing.T) {
	type typ struct {
		A int
		B string
	}
	data := typ{
		A: 1,
		B: "hello",
	}
	trySender, err := bloat.NewBloat[typ](false)
	if err != nil {
		fmt.Println(err)
		t.Errorf("error on newbloat")
	}
	tryReceiver, err := bloat.NewBloat[typ](false)
	if err != nil {
		fmt.Println(err)
		t.Errorf("error on newbloat")
	}
	cyphertext, err := trySender.Write(data, tryReceiver)
	if err != nil {
		fmt.Println(err)
		t.Errorf("error on write")
	}
	fmt.Println(cyphertext)
	plainobj, err := tryReceiver.Read(cyphertext, trySender)
	if err != nil {
		fmt.Println(err)
		t.Errorf("error on read")
	}
	if plainobj.A != 1 {
		fmt.Println(err)
		t.Errorf("int not equal")
	}
	if plainobj.B != "hello" {
		fmt.Println(err)
		t.Errorf("string not hello")
	}

}
