package bloat

import "fmt"

func (b *Bloat[T]) Write(body T, recip Bloat[T]) ([]byte, error) {
	start, err := b.marshal(body)
	if err != nil {
		fmt.Println(err)
		return nil, err
	}
	signed, err := b.sign(start) // our key
	if err != nil {
		fmt.Println(err)
		return nil, err
	}
	final, err := recip.encrypt(signed) // their key
	if err != nil {
		fmt.Println(err)
	}
	return final, err
}
